* NO_APP
RUNS_HUMAN_VERSION	equ	3
	.cpu 68000
	.include doscall.mac
* X68 GCC Develop
	.text
	.even
	.globl _loadBMPfile
_loadBMPfile:
	movem.l d3/a3,-(sp)
	lea.l _psi,a3
	moveq.l #0,d1
	move.w d1,36(a3)	*color= 0
	move.l d1,850(a3)	*clrUsed= 0
	move.l d1,12(a3)	*currentbyte= 0
	move.l d1,62(a3)	*bitcount= 0
	pea 2048.w		*filebufsize for header
	DOS _MALLOC
	move.l d0,4(a3)		*filebuf
	move.l d0,-(sp)
	move.w 2(a3),-(sp)	*fn
	DOS _READ
	lea 10(sp),sp
	jbsr _GetHeaderData
	move.l d0,d3
	cmp.l #200,d0		* ?PICSLICE_NORMAL
	beq headerreadok
	jbsr _EndOfDraw
	move.l d3,d0
	bra loadbmpend
headerreadok:
	tst.l 850(a3)		*clrUsed
	beq paletnouse
	moveq.l #14,d1
	add.l 842(a3),d1	*hsize
	move.l d1,-(sp)
	jbsr _ColorTableGet
	addq.w #4,sp
paletnouse:
	tst.l 838(a3)		*compress
	jbeq headercheckok
	jbsr _EndOfDraw
	moveq.l #101,d0		*PICSLICE_EFORMAT
	add.w d0,d0
	bra loadbmpend
headercheckok:
	moveq.l #1,d0
	move.l d0,834(a3)	*scaleFlag= TRUE
	move.l #1024,d0
	moveq.l #4,d1
	cmp.l 54(a3),d1		*psi.freelist(_bitcount)
	blt bitover4
	add.w d0,d0
bitover4:
	move.l d0,854(a3)	*linebites
	move.l 20(a3),d2	*width
	move.l d2,16(a3)	*realwidth
	move.l 24(a3),d1	*height
	move.l d1,28(a3)	*currenty
	move.l d1,32(a3)	*runlength
	lsr.w #1,d0
	cmp.l d0,d2
	jbgt outview
	cmp.l d0,d1
	jbgt outview
	moveq.l #0,d0
	move.l d0,834(a3)	*scaleFlag
	jbra bitcheck
outview:
	cmp.l d1,d2
	jble tatenaga
	move.l d0,16(a3)	*realwidth
	mulu d0,d1
	move.l d2,-(sp)
	move.l d1,-(sp)
	jbsr ___divsi3
	addq.w #8,sp
	move.l d0,32(a3)	*runlength
	jbsr _makelpat
	move.l d0,38(a3)	*chainbuf
	jbra bitcheck
tatenaga:
	move.l d0,32(a3)	*runlength(realheight)
	mulu d0,d2
	move.l d1,-(sp)
	move.l d2,-(sp)
	jbsr ___divsi3
	addq.w #8,sp
	move.l d0,16(a3)	*realwidth
	jbsr _makelpat
	move.l d0,38(a3)	*chainbuf
bitcheck:
	move.l 20(a3),d0	*psi.width
	move.l 54(a3),d1	*psi.freelist(_bitcount)
	subq.l #1,d1
	beq bit1set
	subq.l #3,d1
	beq bit4set
	subq.l #4,d1
	beq bit8set
bit24set:			*24bit color
	move.l d0,d1
	add.l d1,d1
	add.l d1,d0		*psi.width * 3
	addq.l #3,d0
	move.l	#?bit16col,54(a3)
	move.l #256,850(a3)	*clrUsed
	moveq.l #2,d2
	jbra bufsizeget
bit1set:			*1bit color
	addq.l #7,d0
	asr.l #3,d0
	addq.l #3,d0
	move.l	#?bit1col,54(a3)
	moveq.l #0,d2
	jbra bufsizeget
bit4set:			*4bit color
	addq.l #1,d0
	asr.l #1,d0
	addq.l #3,d0
	move.l	#?bit4col,54(a3)
	moveq.l #0,d2
	jbra bufsizeget
bit8set:			*8bit color
	addq.l #3,d0
	move.l	#?bit8col,54(a3)
	moveq.l #1,d2
bufsizeget:
	moveq.l #-4,d1		*~3
	and.l d1,d0
	move.l d0,42(a3)	*chainbufsize
	move.l 4(a3),-(sp)
	DOS _MFREE
	move.l 42(a3),d0	*chainbufsize
	move.l _dy,d1
	mulu	d1,d0		*chainbufsize * dy
	move.l d0,8(a3)		*filebufsize
	move.l d0,-(sp)
	DOS _MALLOC
	move.l d0,4(a3)		*filebuf
	move.l 32(a3),46(a3)	*psi.top(_y)= psi.runlength(realheight)
	clr.w -(sp)
	move.l 846(a3),-(sp)	*ioffset
	move.w 2(a3),-(sp)	*fn
	DOS _SEEK
	lea.l 16(sp),sp
	move.l d2,_curgmode
	move.l 850(a3),-(sp)	*clrUsed
	pea 66(a3)		*colortable
	jbsr _SetPalet
	addq.l #8,sp
	move.l #_DrawBMPNonScale,_drawfunc
	tst.l 834(a3)		*scaleFlag
	jbeq notscaleset
	move.l 8(a3),-(sp)	*filebufsize
	move.l 4(a3),-(sp)	*filebuf
	move.w 2(a3),-(sp)	*fn
	DOS _READ
	lea.l 10(sp),sp
	move.w _dy+2,36(a3)	*psi.color= dy
	moveq.l #0,d1
	move.l d1,12(a3)	*psi.currentbyte= 0
	move.l #_DrawBMPScale,_drawfunc
notscaleset:
	moveq.l #1,d1
	move.l d1,_drawing	*drawing= TRUE
	move.l 46(a3),d0	*y
	subq.l #1,d0
	move.l 854(a3),d1
	mulu d1,d0		*1024 * (y - 1)
	add.l #$c00000,d0
	move.l d0,50(a3)	*psi.bottom(_adrs)
	moveq.l #100,d0
	add.w d0,d0		*PICSLICE_NORMAL
loadbmpend:
	movem.l (sp)+,d3/a3
	rts
	.even
_GetHeaderData:
	movem.l a3/a4,-(sp)
	lea _psi,a4
	move.l 4(a4),a2		*filebuf
	move.l 12(a4),d0	*currentbyte
	lea.l (a2,d0.l),a2
	move.b (a2)+,d0		*id
	lsl.w #8,d0		*id * 256
	move.b (a2)+,d0
	addq.l #2,12(a4)	*currentbyte += 2
	cmp.w #$424d,d0
	jbne eformat
	lea _Get4Bytes,a3
	jbsr (a3)		*checkfilesize
	jbsr (a3)		*getrsv
	tst.l d0
	jbne eformat
	jbsr (a3)
	move.l d0,846(a4)	*ioffset
	jbsr (a3)
	move.l d0,842(a4)	*hsize
	moveq.l #40,d1		*Windows 3.0 format
	cmp.l d0,d1
	jbeq win3form
	moveq.l #12,d1		*OS/2 1.x format
	cmp.l d0,d1
	jbeq os2form
	moveq.l #64,d1		*OS/2 2.0 format
	cmp.l d0,d1
	jbne eformat
os2form:
	lea _Get2Bytes,a3
win3form:
	jbsr (a3)
	move.l d0,20(a4)	*width
	jbsr (a3)
	move.l d0,24(a4)	*height
	jbsr _Get2Bytes
	moveq.l #1,d1
	cmp.l d0,d1		*?planes == 1
	jbeq formatok
eformat:
	moveq.l #101,d0		*PICSLICE_EFORMAT
	bra formEend
formatok:
	jbsr _Get2Bytes
	move.l d0,54(a4)	*bitcount
	move.l 842(a4),d0	*hsize
	moveq.l #12,d1		*OS/2 2.x
	cmp.l d0,d1
	beq os2_1
	jbsr _Get4Bytes
	move.l d0,838(a4)	*compress
	moveq.l #-14,d0
	add.l 846(a4),d0	*ioffset
	sub.l 842(a4),d0	*hsize
	jbpl plus
	addq.l #3,d0
plus:
	asr.l #2,d0
	move.l d0,850(a4)	*clrUsed
	jbra formNORend
os2_1:				*OS/2 1.x
	moveq.l #0,d0
	move.l d0,838(a4)	*compress
	move.l d0,850(a4)	*clrUsed
formNORend:
	moveq.l #100,d0
formEend:
	add.w d0,d0
	movem.l (sp)+,a3/a4
	rts
	.even
_ColorTableGet:
	move.l 4(sp),d1		*currentbyte
	move.l d3,-(sp)
	lea.l _psi,a2
	lea.l 12(a2),a1		*currentbyte
	move.l d1,(a1)
	move.l 4(a2),a0		*filebuf
	lea.l (a0,d1.l),a0
	move.l 850(a2),d3	*clrUsed
	moveq.l #$fffffff8,d2
	move.l 830(a2),d0	*hsize
	lea.l 66(a2),a2		*colortable
	moveq.l #12,d1		*OS/2 1.x
	cmp.l d0,d1
	bne mkcolent
	swap.w d2
	clr.w d2
	swap.w d2
	bra mkcolent
mkcollp:
	move.b (a0)+,d1		*B
	lsr.b #3,d1
	move.b (a0)+,d0		*G
	lsl.w #5,d0
	move.b (a0)+,d0		*R
	and.w d2,d0
	add.w d0,d0
	add.w d0,d0
	or.b d1,d0
	add.w d0,d0
	move.w d0,(a2)+
	tst.l d2
	bmi notOS2_1
	addq.l #3,(a1)		*currentbyte += 3
	bra mkcolent
notOS2_1:
	addq.l #1,a0
	addq.l #4,(a1)		*currentbyte += 4
mkcolent:
	dbra d3,mkcollp
	move.l (sp)+,d3
	rts
	.even
	.globl _DrawBMPScale
_DrawBMPScale:
	movem.l d3/d4/d5/d6/d7/a3/a4/a5/a6,-(sp)
	clr.l -(sp)
	DOS _SUPER
	move.l d0,(sp)
	move.l _dy,d3
	moveq.l #$fffffff8,d2
	lea _psi,a6
	move.l 54(a6),a2
	movea.l 4(a6),a1
	movea.l 50(a6),a3
	move.w 36(a6),d4	*psi.color(linect)
	movea.w 30(a6),a5	*psi.currenty(OriginY)
	move.l 12(a6),d6	*bytecount
	adda.l d6,a1
	jbra ?64
?75:
	subq.l #1,46(a6)
	cmpa.l #12582911,a3
	jbgt ?67
	jbsr _EndOfDraw
	move.l 16(a6),20(a6)	*width= realwidth
	move.l 32(a6),24(a6)	*height= runlength
	move.l 854(a6),d0
	lsr.w #1,d0
	move.l d0,16(a6)	*realwidth
	jbsr _RectPut
	jbra ?65
?67:
	move.l 46(a6),d0
	move.l 24(a6),d1	*psi.height
	mulu d1,d0
	move.l 32(a6),d1	*psi.runlength(realheight)
	divu d1,d0
	cmp.w a5,d0		*psi.currenty(OriginY)
	jbge ?68
	jbra ?69
?73:
	move.l 46(a6),d0
	move.l 24(a6),d1	*psi.height
	mulu d1,d0
	move.l 32(a6),d1	*psi.runlength(realheight)
	divu d1,d0
	cmp.w a5,d0		*psi.currenty(OriginY)
	jbge ?74
	subq.w #1,d4		*psi.color(linect)
	jbpl ?71
	move.l 8(a6),-(sp)
	move.l 4(a6),-(sp)
	move.w 2(a6),-(sp)
	DOS _READ
	lea 10(sp),sp
	movea.l 4(a6),a1
	moveq.l #0,d6		*bytecount
	move.w _dy+2,d1
	subq.w #1,d1
	move.w d1,d4
?71:
	subq.w #1,a5		*psi.currenty(OriginY)
_DrawBMPline:
	move.l a3,-(sp)
	move.l 38(a6),a4	*lpat
	move.w 22(a6),d5	*psi.width
	moveq.l #0,d7
	jbra nextdot_s
pset_s_lp:
	jsr (a2)
	tst.b (a4)+
	jbeq nextdot_s
	move.w d0,(a3)+
nextdot_s:
	dbra d5,pset_s_lp
	jbra lwnor_s_ent
lwnor_s_lp:
	addq.l #1,d6
	addq.l #1,a1
lwnor_s_ent:
	moveq.l #3,d0
	and.l d6,d0
	jbne lwnor_s_lp
	move.l (sp)+,a3
?69:
	cmpa.l #12582911,a3
	jbgt ?73
	jbra ?74
?68:
	move.l 854(a6),-(sp)
	movea.l a3,a0
	adda.l 854(a6),a0
	move.l a0,-(sp)
	move.l a3,-(sp)
	jbsr _memcpy
	lea 12(sp),sp
?74:
	suba.l 854(a6),a3
?64:
	dbra d3,?75
?65:
	move.l d6,12(a6)	*bytecount
	move.w d4,36(a6)	*psi.color(linect)
	move.l a3,50(a6)
	move.w a5,30(a6)	*psi.currenty(OriginY)
	DOS _SUPER
	addq.w #4,sp
	movem.l (sp)+,d3/d4/d5/d6/d7/a3/a4/a5/a6
	rts
	.globl _DrawBMPNonScale
_DrawBMPNonScale:
	movem.l d3/d4/d5/d6/d7/a3/a4/a5/a6,-(sp)
	lea _psi,a6
	move.l 8(a6),-(sp)
	move.l 4(a6),-(sp)
	move.w 2(a6),-(sp)
	DOS _READ
	lea 10(sp),sp
	clr.l -(sp)
	DOS _SUPER
	move.l d0,(sp)
	move.l 54(a6),a2
	move.l 854(a6),d3
	move.l _dy,d5
	movea.l 46(a6),a0
	movea.l 50(a6),a4
	movea.l 4(a6),a1	*filebuf
	moveq.l #0,d7
	move.w 22(a6),a3	*22(psi)->a3	width
	moveq.l #0,d6		*bytecount
	moveq.l #$fffffff8,d2
	jbra ?96
?108:
	subq.l #1,a0
	cmp.l #12582911,a4
	jbgt ?99
	jbsr _EndOfDraw
	lsr.w #1,d3
	move.l d3,16(a6)	*realwidth
	jbsr _RectPut
	jbra ?97
?99:
	move.w a3,d4
	movea.l a4,a5
	jbra nextdot
psetlp:
	jsr (a2)
	move.w d0,(a5)+
nextdot:
	dbra d4,psetlp
	jbra lwnormalizeent
lwnormalizelp:
	addq.l #1,d6
lwnormalizeent:
	moveq.l #3,d0
	and.b d6,d0
	jbne lwnormalizelp
	movea.l 4(a6),a1	*filebuf
	adda.l d6,a1		*currentbyte
	moveq.l #0,d7
	suba.l d3,a4
?96:
	dbra d5,?108
?97:
	move.l a4,50(a6)
	move.l a0,46(a6)
	DOS _SUPER
	addq.l #4,sp
	movem.l (sp)+,d3/d4/d5/d6/d7/a3/a4/a5/a6
	rts
	.even
?bit1col:
	subq.b #1,d7
	bgt readnextbit1
	moveq.l #0,d0
	move.b (a1)+,d0		*currentbyte
	move.w d0,60(a6)	*_leftData
	addq.l #1,d6		*bytecount
	moveq.l #8,d7
readnextbit1:
	moveq.l #0,d0
	move.w 60(a6),d1	*_leftData
	jbge ?bit1off
	moveq.l #1,d0
?bit1off:
	add.w d1,d1
	move.w d1,60(a6)	*_leftData
	rts
?bit4col:
	subq.w #1,d7
	bgt readnextbit4
	moveq.l #0,d0
	move.b (a1)+,d0		*currentbyte
	move.w d0,60(a6)
	addq.l #1,d6		*bytecount
	moveq.l #2,d7
readnextbit4:
	move.w 60(a6),d1
	move.w d1,d0
	lsl.b #4,d1
	move.w d1,60(a6)
	lsr.b #4,d0
*	and.w #15,d0
	rts
?bit8col:
	addq.l #1,d6		*bytecount
*	moveq.l #0,d0
	move.b (a1)+,d0		*currentbyte
	rts
?bit16col:
	addq.l #3,d6		*bytecount
	move.b (a1)+,d1		*currentbyte
	lsr.b #3,d1	*B
	move.b (a1)+,d0	*G
	lsl.w #5,d0
	move.b (a1)+,d0	*R
	and.b d2,d0
	add.w d0,d0
	add.w d0,d0
	add.b d1,d0
	add.w d0,d0
	rts
	.even
_Get2Bytes:
	lea _psi,a0
	lea 4(a0),a1
	lea 12(a0),a0
	addq.l #2,(a0)
	move.l (a1),a2
	adda.l (a0),a2
	moveq.l #0,d0
	move.b -(a2),d0
	lsl.w #8,d0
	add.b -(a2),d0
	rts
	.even
_Get4Bytes:
	lea _psi,a0
	lea 4(a0),a1
	lea 12(a0),a0
	addq.l #4,(a0)
	move.l (a1),a2
	moveq.l #0,d0
	adda.l (a0),a2
	move.b -(a2),d0
	lsl.w #8,d0
	add.b -(a2),d0
	swap.w	d0
	move.b -(a2),d0
	lsl.w #8,d0
	add.b -(a2),d0
	rts
	.even
_makelpat:
	movem.l d3/d4/d5/d6,-(sp)
	lea _psi,a0
	move.l 20(a0),d0
	move.w d0,d4
	subq.w #1,d4
	move.w d4,d3
	neg.w d3
	move.w d4,d1
	ext.l d1
	add.l d1,d1
	move.w d1,d6
	move.l 16(a0),d1
	subq.l #1,d1
	add.l d1,d1
	move.w d1,d5
	move.l d0,-(sp)
	DOS _MALLOC
	move.l d0,a1
	move.l a1,a0
	move.b #1,(a1)
	addq.w #1,a0
	addq.w #4,sp
?143:
	add.w d5,d3
	jbmi ?146
	move.b #1,(a0)+
	sub.w d6,d3
	jbra ?145
?146:
	clr.b (a0)+
?145:
	subq.w #1,d4
	jbne ?143
	move.l a1,d0
	movem.l (sp)+,d3/d4/d5/d6
	rts
	.even
	.end
